#property copyright "Copyright  2006"

extern string Desc1 = "Use this settings for single position";
extern int atProfit = 30;
extern bool useTrailingStop = TRUE;
extern string Desc2 = "% of protected profit";
extern double keepProfitPercent = 30.0;

int init() {
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS);
      if (OrderType() == OP_BUY && OrderSymbol() == Symbol()) {
         if (Bid - OrderOpenPrice() >= atProfit * Point && (Bid - OrderOpenPrice()) * keepProfitPercent / 100.0 >= OrderStopLoss() - OrderOpenPrice() && useTrailingStop == TRUE)
            if ((Bid - OrderOpenPrice()) * (1 - keepProfitPercent / 100.0) >= 10.0 * Point && OrderOpenPrice() + (Bid - OrderOpenPrice()) * keepProfitPercent / 100.0 != OrderStopLoss()) OrderModify(OrderTicket(), 0, OrderOpenPrice() + (Bid - OrderOpenPrice()) * keepProfitPercent / 100.0, OrderTakeProfit(), 0, Blue);
      }
      if (OrderType() == OP_SELL && OrderSymbol() == Symbol()) {
         ld_0 = OrderStopLoss();
         if (ld_0 == 0.0) ld_0 = OrderOpenPrice() + 10.0 * Point;
         if (OrderOpenPrice() - Ask >= atProfit * Point && (OrderOpenPrice() - Ask) * keepProfitPercent / 100.0 >= OrderOpenPrice() - ld_0 && useTrailingStop == TRUE)
            if ((OrderOpenPrice() - Ask) * (1 - keepProfitPercent / 100.0) >= 10.0 * Point && OrderOpenPrice() - (OrderOpenPrice() - Ask) * keepProfitPercent / 100.0 != OrderStopLoss()) OrderModify(OrderTicket(), 0, OrderOpenPrice() - (OrderOpenPrice() - Ask) * keepProfitPercent / 100.0, OrderTakeProfit(), 0, Blue);
      }
   }
   return (0);
}